Attribute VB_Name = "modCloseWindows"
Option Explicit

Public Const WM_CLOSE = &H10
Public Const MAX_PATH = 260

Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

Private sWindowTitle As String
Public lHwndArr() As Long

'send in a part of the windows name
Public Sub CloseWindow(sPartOfTitle As String)
Dim lIndex As Long
    If Trim(sPartOfTitle) <> vbNullString Then
        ReDim lHwndArr(0)
        'Get all windows matching this string
        getAllWindows sPartOfTitle, frmMain.hWnd
        For lIndex = 0 To UBound(lHwndArr)
            PostMessage lHwndArr(lIndex), WM_CLOSE, 0&, 0&
        Next lIndex
    End If
End Sub

Public Function fEnumWindowsCallBack(ByVal hWnd As Long, ByVal lpData As Long) As Long
Dim lResult As Long
Dim sWndName As String
    
    fEnumWindowsCallBack = 1
    sWndName = Space$(MAX_PATH)
    lResult = GetWindowText(hWnd, sWndName, MAX_PATH)
    sWndName = left$(sWndName, lResult)
    'Search Title for our string
    If (InStr(1, sWndName, sWindowTitle, vbTextCompare) > 0) Then
        'We have a hit, add it to the array
        ReDim Preserve lHwndArr(LBound(lHwndArr) To UBound(lHwndArr) + 1)
        lHwndArr(UBound(lHwndArr)) = hWnd
    End If
End Function

Public Sub getAllWindows(sWinTitle As String, hWnd As Long)
    sWindowTitle = sWinTitle
    Call EnumWindows(AddressOf fEnumWindowsCallBack, hWnd)
End Sub

