Attribute VB_Name = "modFolderStructure"
Option Explicit

'Option Explicit
Private Declare Function CreatePopupMenu Lib "user32" () As Long
Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
'Private Declare Function TrackPopupMenuEx Lib "user32" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal X As Long, ByVal Y As Long, ByVal hWnd As Long, ByVal lptpm As Any) As Long
''Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
'Private Declare Function DestroyMenu Lib "user32" (ByVal hMenu As Long) As Long
'Private Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
'
''Menu
'Const MF_REMOVE = &H1000&
'Const MF_BYPOSITION = &H400&
'Const TPM_LEFTALIGN = &H0&
Const MF_SEPARATOR = &H800&
Const MF_STRING = &H0&
'Const TPM_RETURNCMD = &H100
Const MF_POPUP = &H10&
'Const MF_GRAYED = &H1&
'Const MF_CHECKED = &H8&
''End Menu

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function PathMatchSpec Lib "shlwapi" _
   Alias "PathMatchSpecW" _
  (ByVal pszFileParam As Long, _
   ByVal pszSpec As Long) As Long
   
Const MAX_PATH = 260
Const MAXDWORD = &HFFFF
Const INVALID_HANDLE_VALUE = -1
Const FILE_ATTRIBUTE_ARCHIVE = &H20
Const FILE_ATTRIBUTE_DIRECTORY = &H10
Const FILE_ATTRIBUTE_HIDDEN = &H2
Const FILE_ATTRIBUTE_NORMAL = &H80
Const FILE_ATTRIBUTE_READONLY = &H1
Const FILE_ATTRIBUTE_SYSTEM = &H4
Const FILE_ATTRIBUTE_TEMPORARY = &H100

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Public lMenuIndex As Long
Public sFolderArray() As String

Function StripNulls(OriginalStr As String) As String
    If (InStr(OriginalStr, Chr(0)) > 0) Then
        OriginalStr = left(OriginalStr, InStr(OriginalStr, Chr(0)) - 1)
    End If
    StripNulls = OriginalStr
End Function

Sub FindFilesAPI(sPath As String, sSearchFor As String, sExclude As String, hMenu As Long)
    'KPD-Team 1999
    'E-Mail: KPDTeam@Allapi.net
    'URL: http://www.allapi.net/

    Dim hSub As Long
    Dim sFileName As String ' Walking filename variable...
    Dim sDirName As String ' SubDirectory Name
    Dim sDirNames() As String ' Buffer for directory name entries
    Dim lNumberOfDirs As Long ' Number of directories in this path
    Dim hSearch As Long ' Search Handle
    Dim WFD As WIN32_FIND_DATA
    Dim lCont As Long
    If right(sPath, 1) <> "\" Then sPath = sPath & "\"
    
    ' Search for subdirectories.
    lNumberOfDirs = 0
    ReDim sDirNames(lNumberOfDirs)
    lCont = True
    hSearch = FindFirstFile(sPath & "*", WFD)
    If hSearch <> INVALID_HANDLE_VALUE Then
        Do While lCont
            sDirName = StripNulls(WFD.cFileName)
            ' Ignore the current and encompassing directories.
            If (sDirName <> ".") And (sDirName <> "..") Then
                ' Check for directory with bitwise comparison.
                If GetFileAttributes(sPath & sDirName) And FILE_ATTRIBUTE_DIRECTORY Then
                    sDirNames(lNumberOfDirs) = sDirName
                    lNumberOfDirs = lNumberOfDirs + 1
                    ReDim Preserve sDirNames(lNumberOfDirs)
                End If
            End If
            lCont = FindNextFile(hSearch, WFD) 'Get next subdirectory.
        Loop
        lCont = FindClose(hSearch)
    End If
    
    Dim lIndex As Long
    ' If there are sub-directories...
    If lNumberOfDirs > 0 Then
        ' Recursively walk into them...
        For lIndex = 0 To lNumberOfDirs - 1
            hSub = CreatePopupMenu()
            AppendMenu hMenu, MF_STRING + MF_POPUP, hSub, sDirNames(lIndex)
            FindFilesAPI sPath & sDirNames(lIndex) & "\", sSearchFor, sExclude, hSub
        Next lIndex
    End If
        
    If sSearchFor <> "" Then
        ' Walk through this directory.
        
        'hSearch = FindFirstFile(sPath & sSearchFor, WFD)
        hSearch = FindFirstFile(sPath & "*", WFD)
        lCont = True
        If hSearch <> INVALID_HANDLE_VALUE Then
            While lCont
                sFileName = StripNulls(WFD.cFileName)
                If (sFileName <> ".") And (sFileName <> "..") Then
                    If GetFileAttributes(sPath & sFileName) And Not FILE_ATTRIBUTE_DIRECTORY Then
                        If sExclude = vbNullString Or PathMatchSpec(StrPtr(Trim(WFD.cFileName)), StrPtr(sExclude)) = 0 Then
                            If PathMatchSpec(StrPtr(Trim(WFD.cFileName)), StrPtr(sSearchFor)) Then
                                lMenuIndex = lMenuIndex + 1
                                AppendMenu hMenu, MF_STRING, lMenuIndex, sFileName
                                'Debug.Print lMenuIndex & " " & sPath & sFileName
                                ReDim Preserve sFolderArray(UBound(sFolderArray) + 1)
                                sFolderArray(UBound(sFolderArray)) = sPath & sFileName
                            End If
                        End If
                    End If
                End If
                lCont = FindNextFile(hSearch, WFD) ' Get next file
            Wend
            lCont = FindClose(hSearch)
        End If
    End If
    
    'AppendMenu hMenu, MF_SEPARATOR, 0, "-"
    lMenuIndex = lMenuIndex + 1
    AppendMenu hMenu, MF_STRING, lMenuIndex, "."
    'Debug.Print lMenuIndex & " " & sPath
    ReDim Preserve sFolderArray(UBound(sFolderArray) + 1)
    sFolderArray(UBound(sFolderArray)) = sPath
End Sub



